﻿require.config({
    paths: {
        eeHelper: ["/-/speak/v1/ExperienceEditor/ExperienceEditor", "/-/speak/v1/ExperienceEditor/Commands/stub"]
    }
});

define(["sitecore", "eeHelper"], function (Sitecore, ExperienceEditor) {
    Sitecore.Commands.ShowXPerience =
    {
        commandContext: null,
        isEnabled: false,

        reEvaluate: function () {
            this.canExecute(Sitecore.Commands.ShowXPerience.commandContext);
            if (Sitecore.Commands.ShowXPerience.commandContext) {
                Sitecore.Commands.ShowXPerience.commandContext.button.set("isEnabled", this.isEnabled);
            }
        },
        canExecute: function (context) {
            var isInModeFn = (typeof ExperienceEditor !== typeof void 0 && ExperienceEditor.isInMode || typeof Sitecore.ExperienceEditor != typeof void 0 && Sitecore.ExperienceEditor.isInMode instanceof Function && Sitecore.ExperienceEditor.isInMode).bind(typeof ExperienceEditor !== typeof void 0 && ExperienceEditor || typeof Sitecore.ExperienceEditor != typeof void 0 && Sitecore.ExperienceEditor);

            if (!isInModeFn("edit")
                || !context
                || !context.button
                || (typeof context.currentContext != typeof void 0 && typeof context.currentContext.isFallback != typeof void 0 && context.currentContext.isFallback)) {
                return false;
            }

            var isAllowed = (typeof ExperienceEditor !== typeof void 0 && ExperienceEditor.isEditingAndDesigningAllowed instanceof Function && ExperienceEditor.isEditingAndDesigningAllowed 
                             || function (){ return Sitecore.Commands.EnableEditing.isEnabled || Sitecore.Commands.EnableDesigning.isEnabled; } )()
            //var isAllowed = ExperienceEditor.isEditingAndDesigningAllowed();

            if (!Sitecore.Commands.ShowXPerience.commandContext) {
                Sitecore.Commands.ShowXPerience.commandContext = (typeof ExperienceEditor !== typeof void 0 && ExperienceEditor.getContext instanceof Function && ExperienceEditor.getContext() || typeof Sitecore.ExperienceEditor != typeof void 0 && Sitecore.ExperienceEditor).instance.clone(context);
            }

            this.isEnabled = isAllowed;
            return this.isEnabled;
        },
        execute: function (context) {
            // (typeof ExperienceEditor !== typeof void 0 && ExperienceEditor.PipelinesUtil || typeof Sitecore.ExperienceEditor != typeof void 0 && Sitecore.ExperienceEditor.PipelinesUtil)

            (typeof ExperienceEditor !== typeof void 0 && ExperienceEditor.PipelinesUtil || typeof Sitecore.ExperienceEditor != typeof void 0 && Sitecore.ExperienceEditor.PipelinesUtil).generateRequestProcessor("ExperienceEditor.ToggleRegistryKey.Toggle", function (response) {
                var isCheckedValue = response.responseValue.value ? "1" : "0";

                response.context.button.set("isChecked", isCheckedValue);

                if (isCheckedValue === "1") {
                    window.top.BrainJocks
                        && window.top.BrainJocks.EE
                        && window.top.BrainJocks.EE.xprManager
                        && typeof window.top.BrainJocks.EE.xprManager.show === "function"
                        && window.top.BrainJocks.EE.xprManager.show();
                }
                else {
                    window.top.BrainJocks
                        && window.top.BrainJocks.EE
                        && window.top.BrainJocks.EE.xprManager
                        && typeof window.top.BrainJocks.EE.xprManager.hide === "function"
                        && window.top.BrainJocks.EE.xprManager.hide();
                }

            }, { value: context.button.get("registryKey") }).execute(context);
        }
    };
});




